<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: hash_table.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">hash_table.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2003  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_HASH_TABLe_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_HASH_TABLe_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;hash_table/hash_table_kernel_1.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;hash_table/hash_table_kernel_2.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;hash_table/hash_table_kernel_c.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;algs.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;binary_search_tree.h&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;{</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="keyword">typename</span> domain,</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <span class="keyword">typename</span> range,</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keyword">typename</span> mem_manager = <a class="code" href="namespacedlib.html#ae8aaef18fce6452263f46535116308ca">default_memory_manager</a>,</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <span class="keyword">typename</span> compare = std::less&lt;domain&gt;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        &gt;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="classdlib_1_1hash__table.html">   25</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1hash__table.html">hash_table</a></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <a class="code" href="classdlib_1_1hash__table.html">hash_table</a>() {}</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classdlib_1_1binary__search__tree__kernel__1.html">binary_search_tree&lt;domain,range,mem_manager,compare&gt;::kernel_1a</a></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;                    <a class="code" href="classdlib_1_1binary__search__tree__kernel__1.html">bst_1</a>;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classdlib_1_1binary__search__tree__kernel__2.html">binary_search_tree&lt;domain,range,mem_manager,compare&gt;::kernel_2a</a></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;                    <a class="code" href="classdlib_1_1binary__search__tree__kernel__2.html">bst_2</a>;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        </div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="comment">//----------- kernels ---------------</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="comment">// kernel_1a        </span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keyword">typedef</span>     <a class="code" href="classdlib_1_1hash__table__kernel__1.html">hash_table_kernel_1&lt;domain,range,mem_manager,compare&gt;</a>    </div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;                    <a class="code" href="classdlib_1_1hash__table__kernel__1.html">kernel_1a</a>;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keyword">typedef</span>     <a class="code" href="classdlib_1_1hash__table__kernel__c.html">hash_table_kernel_c&lt;kernel_1a&gt;</a></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;                    <a class="code" href="classdlib_1_1hash__table__kernel__c.html">kernel_1a_c</a>;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="comment">// kernel_2a        </span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="keyword">typedef</span>     <a class="code" href="classdlib_1_1hash__table__kernel__2.html">hash_table_kernel_2&lt;domain,range,bst_1,mem_manager,compare&gt;</a>    </div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                    <a class="code" href="classdlib_1_1hash__table__kernel__2.html">kernel_2a</a>;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keyword">typedef</span>     <a class="code" href="classdlib_1_1hash__table__kernel__c.html">hash_table_kernel_c&lt;kernel_2a&gt;</a></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;                    <a class="code" href="classdlib_1_1hash__table__kernel__c.html">kernel_2a_c</a>;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="comment">// kernel_2b</span></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="keyword">typedef</span>     <a class="code" href="classdlib_1_1hash__table__kernel__2.html">hash_table_kernel_2&lt;domain,range,bst_2,mem_manager,compare&gt;</a>    </div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;                    <a class="code" href="classdlib_1_1hash__table__kernel__2.html">kernel_2b</a>;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="keyword">typedef</span>     <a class="code" href="classdlib_1_1hash__table__kernel__c.html">hash_table_kernel_c&lt;kernel_2b&gt;</a></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;                    <a class="code" href="classdlib_1_1hash__table__kernel__c.html">kernel_2b_c</a>;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    };</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;}</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="preprocessor">#endif // DLIB_HASH_TABLe_</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1hash__table__kernel__c_html"><div class="ttname"><a href="classdlib_1_1hash__table__kernel__c.html">dlib::hash_table_kernel_c</a></div><div class="ttdef"><b>Definition:</b> hash_table_kernel_c.h:17</div></div>
<div class="ttc" id="aclassdlib_1_1hash__table__kernel__2_html"><div class="ttname"><a href="classdlib_1_1hash__table__kernel__2.html">dlib::hash_table_kernel_2</a></div><div class="ttdef"><b>Definition:</b> hash_table_kernel_2.h:26</div></div>
<div class="ttc" id="anamespacedlib_html_ae8aaef18fce6452263f46535116308ca"><div class="ttname"><a href="namespacedlib.html#ae8aaef18fce6452263f46535116308ca">dlib::default_memory_manager</a></div><div class="ttdeci">memory_manager_stateless_kernel_1&lt; char &gt; default_memory_manager</div><div class="ttdef"><b>Definition:</b> algs.h:129</div></div>
<div class="ttc" id="aclassdlib_1_1hash__table_html"><div class="ttname"><a href="classdlib_1_1hash__table.html">dlib::hash_table</a></div><div class="ttdef"><b>Definition:</b> hash_table.h:25</div></div>
<div class="ttc" id="aclassdlib_1_1binary__search__tree__kernel__1_html"><div class="ttname"><a href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a></div><div class="ttdef"><b>Definition:</b> binary_search_tree_kernel_1.h:24</div></div>
<div class="ttc" id="aclassdlib_1_1binary__search__tree__kernel__2_html"><div class="ttname"><a href="classdlib_1_1binary__search__tree__kernel__2.html">dlib::binary_search_tree_kernel_2</a></div><div class="ttdef"><b>Definition:</b> binary_search_tree_kernel_2.h:23</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<div class="ttc" id="aclassdlib_1_1hash__table__kernel__1_html"><div class="ttname"><a href="classdlib_1_1hash__table__kernel__1.html">dlib::hash_table_kernel_1</a></div><div class="ttdef"><b>Definition:</b> hash_table_kernel_1.h:26</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
